package ch.nuage.arduage;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.TextView;

import com.ftdi.j2xx.D2xxManager.D2xxException;

public class MainActivity extends Activity {

	private Ardunio ardunio;

	private SeekBar seekB;

	private SeekBar seekG;

	private SeekBar seekR;
	private TextView t;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		t = ((TextView) findViewById(R.id.textActivityMain));

		seekR = ((SeekBar) findViewById(R.id.seekBarR));
		seekG = ((SeekBar) findViewById(R.id.seekBarG));
		seekB = ((SeekBar) findViewById(R.id.seekBarB));

		try {
			ardunio = new Ardunio(this) {

				@Override
				public void info(final String txt) {
					runOnUiThread(new Runnable() {
						@Override
						public void run() {
							t.setText(txt);
						}
					});
				}

			};
		} catch (D2xxException e) {
			t.setText(e.getMessage());
		}

		seekR.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {

			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				ardunio.setLedR(progress);
			}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
			}

			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
			}
		});

		seekG.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {

			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				ardunio.setLedG(progress);
			}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
			}

			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
			}
		});

		seekB.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {

			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				ardunio.setLedB(progress);
			}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
			}

			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
			}
		});

		((Button) findViewById(R.id.buttonGetTemperature))
				.setOnClickListener(new OnClickListener() {
					@Override
					public void onClick(View v) {
						ardunio.temperature();
					}
				});

		((Button) findViewById(R.id.buttonHelp))
				.setOnClickListener(new OnClickListener() {
					@Override
					public void onClick(View v) {
						ardunio.help();
					}
				});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public void onPause() {
		super.onPause();
		ardunio.shutdown();
	}

	@Override
	protected void onResume() {
		super.onResume();
		ardunio.start();
	}

}
